/************************** cvtsyslogdate.c *******************************/

/******************************************************************************
 * Copyright (c) 1995,1996 Donated to the public domain                       *
 *                                                                            *
 * Original author and maintainer: Marc Chatel   (mchatel@dial.oleane.com)    *
 * Last known maintainer:          Marc Chatel   (mchatel@dial.oleane.com)    *
 *                                                                            *
 * This file was created as part of the S4 (Secure System Setup Script) kit.  *
 * Permission is granted to any person or entity to do any of the following:  *
 *       a) use this file alone or in some other software                     *
 *       b) modify this file or include parts of this file in other files     *
 *       c) re-distribute this file AS IS or modified, for non-commercial     *
 *          or commercial purposes, alone or as part of some software package *
 *                                                                            *
 * No warranties of any kind, express or implied, on the functionality and    *
 * safety of the contents of this file. Use at your own risk!                 *
 *                                                                            *
 * If you do useful changes to this file (bug fixes, portability fixes,       *
 * enhancements), you should TRY to contact the current maintainer, who may   *
 * be maintaining a "latest greatest" version of the file. You do not HAVE    *
 * TO, but you should TRY. Promote software reuse! It helps everybody,        *
 * including you!                                                             *
 ******************************************************************************/

#include <time.h>
#include <stdio.h>
#include <string.h>

#define NAMELEN   12

char *my_months[12] = { "JAN", "FEB", "MAR", "APR", "MAY", "JUN",
                        "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"  };

int main( argc, argv )
int argc;
char **argv;
{
   time_t     syslog_time, current_time;
   struct tm  our_values, *tmp_ptr;
   char       syslog_name[NAMELEN];

   if (argc != 2) return 1;

   (void) time( &current_time );
   tmp_ptr = localtime( &current_time );
   our_values = *tmp_ptr;

   /* our_values now contain the current ones */

   if (strlen(argv[1]) > NAMELEN)   return 1;

   strcpy( syslog_name, argv[1] );

   if ((syslog_name[0] < '0') || (syslog_name[0] > '9'))    return 1;
   if ((syslog_name[1] < '0') || (syslog_name[1] > '9'))    return 1;
   if (syslog_name[2] != '-')                               return 1;
   syslog_name[3] = toupper( syslog_name[3] );
   if ((syslog_name[3] < 'A') || (syslog_name[3] > 'Z'))    return 1;
   syslog_name[4] = toupper( syslog_name[4] );
   if ((syslog_name[4] < 'A') || (syslog_name[4] > 'Z'))    return 1;
   syslog_name[5] = toupper( syslog_name[5] );
   if ((syslog_name[5] < 'A') || (syslog_name[5] > 'Z'))    return 1;
   if (syslog_name[6] != '-')                               return 1;
   if ((syslog_name[7] < '0') || (syslog_name[7] > '9'))    return 1;
   if ((syslog_name[8] < '0') || (syslog_name[8] > '9'))    return 1;
   if (syslog_name[9] != ':')                               return 1;
   if ((syslog_name[10] < '0') || (syslog_name[10] > '9'))  return 1;
   if ((syslog_name[11] < '0') || (syslog_name[11] > '9'))  return 1;
   if (syslog_name[12] != '\0')                             return 1;

   syslog_name[2] = '\0';
   syslog_name[6] = '\0';
   syslog_name[9] = '\0';

   our_values.tm_isdst = -1;
   our_values.tm_sec   = 0;

   if (syslog_name[0] == '0')  our_values.tm_mday = atoi( syslog_name + 1 );
   else                        our_values.tm_mday = atoi( syslog_name );

   {
      int my_idx = 11;

      while (my_idx >= 0)
      {
         if (strcmp( my_months[my_idx], syslog_name + 3 ) == 0)  break;
         my_idx--;
      }
      if (my_idx < 0)  return 1;

      our_values.tm_mon = my_idx;
   } 
  
   if (syslog_name[7] == '0')  our_values.tm_hour = atoi( syslog_name + 8 );
   else                        our_values.tm_hour = atoi( syslog_name + 7 );

   if (syslog_name[10] == '0') our_values.tm_min = atoi( syslog_name + 11 );
   else                        our_values.tm_min = atoi( syslog_name + 10 );

   syslog_time = mktime( &our_values );

   if (syslog_time > current_time)
   {
      our_values.tm_year--;
      syslog_time = mktime( &our_values );
   }

   if (syslog_time > current_time)   return 1;

   printf("%ld\n", (long) syslog_time );
   return 0;
}

